#pragma once
#include <fcntl.h>
#ifndef _POSIX_SOURCE /* No posix. */
#include <stdio.h>
#endif
#include <stdint.h>
#include <sys/types.h>

struct Packfile_s;
typedef struct Packfile_s Packfile_t;

/* Packfile manipulation. Automatically allocated and freed (with open and close). */

/* Basic. */
int pack_check(const char* filename);
int pack_files(const char* outfile, const char** infiles, const uint32_t nfiles);
Packfile_t* pack_open(const char* packfile, const char* filename);
ssize_t pack_read(Packfile_t* file, void* buf, const size_t count);
off_t pack_seek(Packfile_t* file, off_t offset, int whence);
long pack_tell(Packfile_t* file);
int pack_close(Packfile_t* file);

/* Fancy stuff. */
void* pack_readfile(const char* packfile, const char* filename, uint32_t* filesize);
char** pack_listfiles(const char* packfile, uint32_t* nfiles);

